## nvme-cli 0.5

=== Makefile ===
CFLAGS += -std=gnu99 -O2 -g -Wall -Werror
CPPFLAGS += -I $(SRC) -D_GNU_SOURCE
NVME = nvme
INSTALL ?= install
SRC = ./src
DESTDIR =
PREFIX ?= /usr/local
SBINDIR = $(PREFIX)/sbin
LIBUDEV := $(shell ld -o /dev/null -ludev >/dev/null 2>&1; echo $$?)
LIB_DEPENDS =

RPMBUILD = rpmbuild
TAR = tar
RM = rm -f

AUTHOR=Keith Busch <keith.busch@intel.com>

ifeq ($(LIBUDEV),0)
	override LDFLAGS += -ludev
	override CFLAGS  += -DLIBUDEV_EXISTS
	override LIB_DEPENDS += udev
endif

default: $(NVME)

NVME-VERSION-FILE: FORCE
	@$(SHELL_PATH) ./NVME-VERSION-GEN
-include NVME-VERSION-FILE
override CFLAGS += -DNVME_VERSION='"$(NVME_VERSION)"'

NVME_DPKG_VERSION=1~`lsb_release -sc`

nvme: nvme.c ./linux/nvme.h argconfig.o suffix.o nvme-print.o nvme-ioctl.o NVME-VERSION-FILE
	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c $(LDFLAGS) -o $(NVME) argconfig.o suffix.o nvme-print.o nvme-ioctl.o

nvme-ioctl.o: nvme-ioctl.c nvme-ioctl.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -c nvme-ioctl.c

argconfig.o: $(SRC)/argconfig.c $(SRC)/argconfig.h $(SRC)/suffix.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $(SRC)/argconfig.c

suffix.o: $(SRC)/suffix.c $(SRC)/suffix.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -c $(SRC)/suffix.c

nvme-print.o: nvme-print.c nvme-print.h
	$(CC) $(CPPFLAGS) $(CFLAGS) -c nvme-print.c

doc: $(NVME)
	$(MAKE) -C Documentation

all: doc

clean:
	$(RM) $(NVME) *.o *~ a.out NVME-VERSION-FILE *.tar* nvme.spec version control nvme-*.deb
	$(MAKE) -C Documentation clean

clobber: clean
	$(MAKE) -C Documentation clobber

install-man:
	$(MAKE) -C Documentation install-no-build

install-bin: default
	$(INSTALL) -d $(DESTDIR)$(SBINDIR)
	$(INSTALL) -m 755 nvme $(DESTDIR)$(SBINDIR)

install: install-bin install-man

nvme.spec: nvme.spec.in NVME-VERSION-FILE
	sed -e 's/@@VERSION@@/$(NVME_VERSION)/g' < $< > $@+
	mv $@+ $@

dist: nvme.spec
	git archive --format=tar --prefix=nvme-$(NVME_VERSION)/ HEAD > nvme-$(NVME_VERSION).tar
	@echo $(NVME_VERSION) > version
	$(TAR) rf  nvme-$(NVME_VERSION).tar nvme.spec version
	gzip -f -9 nvme-$(NVME_VERSION).tar

control: nvme.control.in NVME-VERSION-FILE
	sed -e 's/@@VERSION@@/$(NVME_VERSION)/g' < $< > $@+
	mv $@+ $@
	sed -e 's/@@DEPENDS@@/$(LIB_DEPENDS)/g' < $@ > $@+
	mv $@+ $@

pkg: control nvme.control.in
	mkdir -p nvme-$(NVME_VERSION)$(SBINDIR)
	mkdir -p nvme-$(NVME_VERSION)$(PREFIX)/share/man/man1
	mkdir -p nvme-$(NVME_VERSION)/DEBIAN/
	cp Documentation/*.1 nvme-$(NVME_VERSION)$(PREFIX)/share/man/man1
	cp nvme nvme-$(NVME_VERSION)$(SBINDIR)
	cp control nvme-$(NVME_VERSION)/DEBIAN/

# Make a reproducible tar.gz in the super-directory. Uses
# git-restore-mtime if available to adjust timestamps.
../nvme-cli_$(NVME_VERSION).orig.tar.gz:
	find . -type f -perm -u+rwx -exec chmod 0755 '{}' +
	find . -type f -perm -u+rw '!' -perm -u+x -exec chmod 0644 '{}' +
	if which git-restore-mtime >/dev/null; then git-restore-mtime; fi
	git ls-files | tar cf ../nvme-cli_$(NVME_VERSION).orig.tar \
	  --owner=root --group=root \
	  --transform='s#^#nvme-cli-$(NVME_VERSION)/#' --files-from -
	touch -d "`git log --format=%ci -1`" ../nvme-cli_$(NVME_VERSION).orig.tar
	gzip -f -9 ../nvme-cli_$(NVME_VERSION).orig.tar

dist-orig: ../nvme-cli_$(NVME_VERSION).orig.tar.gz

# Create a throw-away changelog, which dpkg-buildpackage uses to
# determine the package version.
deb-changelog:
	printf '%s\n\n  * Auto-release.\n\n %s\n' \
          "nvme-cli ($(NVME_VERSION)-$(NVME_DPKG_VERSION)) `lsb_release -sc`; urgency=low" \
          "-- $(AUTHOR)  `git log -1 --format=%cD`" \
	  > debian/changelog

deb: deb-changelog dist-orig
	dpkg-buildpackage -uc -us -sa

# After this target is build you need to do a debsign and dput on the
# ../<name>.changes file to upload onto the relevant PPA. For example:
#
#  > make AUTHOR='First Last <first.last@company.com>' \
#        NVME_DPKG_VERSION='0ubuntu1' deb-ppa
#  > debsign <name>.changes
#  > dput ppa:<lid>/ppa <name>.changes
#
# where lid is your launchpad.net ID.
deb-ppa: deb-changelog dist-orig
	debuild -uc -us -S

deb-light: $(NVME) pkg nvme.control.in
	dpkg-deb --build nvme-$(NVME_VERSION)

rpm: dist
	$(RPMBUILD) -ta nvme-$(NVME_VERSION).tar.gz

.PHONY: default doc all clean clobber install-man install-bin install
.PHONY: dist pkg dist-orig deb deb-light rpm FORCE

=== Documentation/Makefile ===
# Guard against environment variables
MAN1_TXT =
TECH_DOCS =
ARTICLES =
SP_ARTICLES =

MAN1_TXT += $(filter-out \
		$(addsuffix .txt, $(ARTICLES) $(SP_ARTICLES)), \
		$(wildcard nvme-*.txt))
MAN1_TXT += nvme.txt
MAN_TXT = $(MAN1_TXT)
MAN_XML = $(patsubst %.txt,%.xml,$(MAN_TXT))
MAN_HTML = $(patsubst %.txt,%.html,$(MAN_TXT))

DOC_HTML = $(MAN_HTML) $(OBSOLETE_HTML)

API_DOCS = 
SP_ARTICLES += $(API_DOCS)
SP_ARTICLES += $(TECH_DOCS)


DOC_MAN1 = $(patsubst %.txt,%.1,$(MAN1_TXT))

ASCIIDOC = asciidoc
ASCIIDOC_EXTRA =
ASCIIDOC_DOCBOOK = docbook
ASCIIDOC_COMMON = $(ASCIIDOC) $(ASCIIDOC_EXTRA)
TXT_TO_XML = $(ASCIIDOC_COMMON) -b $(ASCIIDOC_DOCBOOK)
MANPAGE_XSL = manpage-normal.xsl
XMLTO = xmlto
XMLTO_EXTRA =
INSTALL ?= install
RM ?= rm -f
MAN_REPO = ../../nvme-manpages

ASCIIDOC_HTML = xhtml11
ASCIIDOC_CONF = -f asciidoc.conf
ASCIIDOC_COMMON = $(ASCIIDOC) $(ASCIIDOC_EXTRA) $(ASCIIDOC_CONF)
TXT_TO_HTML = $(ASCIIDOC_COMMON) -b $(ASCIIDOC_HTML)

MAKEINFO = makeinfo
INSTALL_INFO = install-info
DOCBOOK2X_TEXI = docbook2x-texi
DBLATEX = dblatex
ASCIIDOC_DBLATEX_DIR = /etc/asciidoc/dblatex
ifndef PERL_PATH
	PERL_PATH = /usr/bin/perl
endif

ifdef DOCBOOK_XSL_172
MANPAGE_XSL = manpage-1.72.xsl
else
	ifndef ASCIIDOC_ROFF
	endif
endif
ifdef MAN_BOLD_LITERAL
XMLTO_EXTRA += -m manpage-bold-literal.xsl
endif
ifdef DOCBOOK_SUPPRESS_SP
XMLTO_EXTRA += -m manpage-suppress-sp.xsl
endif

ifndef MAN_BASE_URL
MAN_BASE_URL = file://$(htmldir)/
endif
XMLTO_EXTRA +=

ifdef GNU_ROFF
XMLTO_EXTRA +=
endif

SHELL_PATH ?= $(SHELL)
# Shell quote;
SHELL_PATH_SQ = $(subst ','\'',$(SHELL_PATH))

ifdef DEFAULT_PAGER
DEFAULT_PAGER_SQ = $(subst ','\'',$(DEFAULT_PAGER))
endif

ifdef DEFAULT_EDITOR
DEFAULT_EDITOR_SQ = $(subst ','\'',$(DEFAULT_EDITOR))
endif

QUIET_SUBDIR0  = +$(MAKE) -C # space to separate -C and subdir
QUIET_SUBDIR1  =

ifneq ($(findstring $(MAKEFLAGS),w),w)
PRINT_DIR = --no-print-directory
else # "make -w"
NO_SUBDIR = :
endif

DESTDIR =
PREFIX := /usr/local

all: man html

html: $(DOC_HTML)

man: man1
man1: $(DOC_MAN1)

install-no-build:
	$(INSTALL) -d -m 755 $(DESTDIR)$(PREFIX)/share/man/man1
	$(INSTALL) -m 644 $(DOC_MAN1) $(DESTDIR)$(PREFIX)/share/man/man1

install: install-man

install-man: man
	$(INSTALL) -d -m 755 $(DESTDIR)$(PREFIX)/share/man/man1
	$(INSTALL) -m 644 $(DOC_MAN1) $(DESTDIR)$(PREFIX)/share/man/man1

docdep_prereqs = \
	cmd-list.made $(cmds_txt)

doc.dep : $(docdep_prereqs) $(wildcard *.txt) build-docdep.perl
	$(QUIET_GEN)$(RM) $@+ $@ && \
	$(PERL_PATH) ./build-docdep.perl >$@+ $(QUIET_STDERR) && \
	mv $@+ $@

-include doc.dep

cmds_txt = cmds-ancillaryinterrogators.txt \
	cmds-ancillarymanipulators.txt \
	cmds-mainporcelain.txt \
	cmds-plumbinginterrogators.txt \
	cmds-plumbingmanipulators.txt \
	cmds-synchingrepositories.txt \
	cmds-synchelpers.txt \
	cmds-purehelpers.txt \
	cmds-foreignscminterface.txt

$(cmds_txt): cmd-list.made

cmd-list.made: cmd-list.perl ../command-list.txt $(MAN1_TXT)
	$(QUIET_GEN)$(RM) $@ && \
	$(PERL_PATH) ./cmd-list.perl ../command-list.txt $(QUIET_STDERR) && \
	date >$@

clean:
	$(RM) *.xml *.xml+ *.html+
	$(RM) *.texi *.texi+ *.texi++ nvme.info nvmeman.info
	$(RM) *.pdf
	$(RM) howto-index.txt howto/*.html doc.dep
	$(RM) technical/*.html technical/api-index.txt
	$(RM) $(cmds_txt) *.made
	$(RM) manpage-base-url.xsl
	$(RM) *~

clobber: clean
	$(RM) *.html *.1

%.1 : %.xml
	$(QUIET_XMLTO)$(RM) $@ && \
	$(XMLTO) -m $(MANPAGE_XSL) $(XMLTO_EXTRA) man $<

%.xml : %.txt 
	$(QUIET_ASCIIDOC)$(RM) $@+ $@ && \
	$(TXT_TO_XML) -d manpage -o $@+ $< && \
	mv $@+ $@

user-manual.xml: user-manual.txt user-manual.conf
	$(QUIET_ASCIIDOC)$(RM) $@+ $@ && \
	$(TXT_TO_XML) -d article -o $@+ $< && \
	mv $@+ $@

technical/api-index.txt: technical/api-index-skel.txt \
	technical/api-index.sh $(patsubst %,%.txt,$(API_DOCS))
	$(QUIET_GEN)cd technical && '$(SHELL_PATH_SQ)' ./api-index.sh

XSLT = docbook.xsl
XSLTOPTS = --xinclude --stringparam html.stylesheet docbook-xsl.css

nvme.info: user-manual.texi
	$(QUIET_MAKEINFO)$(MAKEINFO) --no-split -o $@ user-manual.texi

user-manual.texi: user-manual.xml
	$(QUIET_DB2TEXI)$(RM) $@+ $@ && \
	$(DOCBOOK2X_TEXI) user-manual.xml --encoding=UTF-8 --to-stdout >$@++ && \
	$(PERL_PATH) fix-texi.perl <$@++ >$@+ && \
	rm $@++ && \
	mv $@+ $@

user-manual.pdf: user-manual.xml
	$(QUIET_DBLATEX)$(RM) $@+ $@ && \
	$(DBLATEX) -o $@+ -p $(ASCIIDOC_DBLATEX_DIR)/asciidoc-dblatex.xsl -s $(ASCIIDOC_DBLATEX_DIR)/asciidoc-dblatex.sty $< && \
	mv $@+ $@

nvmeman.texi: $(MAN_XML) cat-texi.perl
	$(QUIET_DB2TEXI)$(RM) $@+ $@ && \
	($(foreach xml,$(MAN_XML),$(DOCBOOK2X_TEXI) --encoding=UTF-8 \
		--to-stdout $(xml) &&) true) > $@++ && \
	$(PERL_PATH) cat-texi.perl $@ <$@++ >$@+ && \
	rm $@++ && \
	mv $@+ $@

nvmeman.info: nvmeman.texi
	$(QUIET_MAKEINFO)$(MAKEINFO) --no-split --no-validate $*.texi

$(patsubst %.txt,%.texi,$(MAN_TXT)): %.texi : %.xml
	$(QUIET_DB2TEXI)$(RM) $@+ $@ && \
	$(DOCBOOK2X_TEXI) --to-stdout $*.xml >$@+ && \
	mv $@+ $@

howto-index.txt: howto-index.sh $(wildcard howto/*.txt)
	$(QUIET_GEN)$(RM) $@+ $@ && \
	'$(SHELL_PATH_SQ)' ./howto-index.sh $(sort $(wildcard howto/*.txt)) >$@+ && \
	mv $@+ $@

WEBDOC_DEST = /pub/software/scm/nvme/docs

$(MAN_HTML): %.html : %.txt
	$(QUIET_ASCIIDOC)$(RM) $@+ $@ && \
	$(TXT_TO_HTML) -d manpage -o $@+ $< && \
	mv $@+ $@

quick-install: quick-install-man

$(patsubst %,%.html,$(ARTICLES)) : %.html : %.txt
	$(QUIET_ASCIIDOC)$(TXT_TO_HTML) $*.txt

install-webdoc : html
	'$(SHELL_PATH_SQ)' ./install-webdoc.sh $(WEBDOC_DEST)

require-manrepo::
	@if test ! -d $(MAN_REPO); \
	then echo "nvme-manpages repository must exist at $(MAN_REPO)"; exit 1; fi

quick-install-man: require-manrepo
	'$(SHELL_PATH_SQ)' ./install-doc-quick.sh $(MAN_REPO) $(DESTDIR)$(mandir)

print-man1:
	@for i in $(MAN1_TXT); do echo $$i; done

.PHONY: FORCE

=== debian/changelog ===
nvme-cli (0.5-1ubuntu0.2) xenial; urgency=medium

  * d/p/0003-Remove-version-from-list.patch:
    Backported from upstream to fix display of information v1.0 m.2
    drives. (LP: #1704817)

 -- Manoj Iyer <manoj.iyer@canonical.com>  Fri, 14 Jul 2017 22:08:23 -0500

nvme-cli (0.5-1ubuntu0.1) xenial; urgency=medium

  * d/p/0001-Fix-the-bug-of-Model-Number-and-display-the-info-of-.patch,
    d/p/0002-Fix-the-bug-of-Model-Number-and-display-the-info-of-.patch:
    cherry-pick patches from upstream to fix display of information for
    devices with long names.  LP: #1595274.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Mon, 17 Oct 2016 17:21:59 -0700

nvme-cli (0.5-1) unstable; urgency=medium

  * New upstream release
    - Fix version number (Closes: #816438)
  * Bump Standard-Version to 3.9.7, no changes required.
  * drop 0004-Fix-English-typos-only.patch: upstream.

 -- Breno Leitao <brenohl@br.ibm.com>  Tue, 22 Mar 2016 10:43:12 -0400

nvme-cli (0.3-1) unstable; urgency=medium

  * Initial release. (Closes: #810033)

 -- Breno Leitao <brenohl@br.ibm.com>  Tue, 05 Jan 2016 14:40:05 -0500

=== debian/control ===
Source: nvme-cli
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Breno Leitao <brenohl@br.ibm.com>
Section: admin
Priority: optional
Standards-Version: 3.9.7
Build-Depends: debhelper (>= 9), libudev-dev
Homepage: https://github.com/linux-nvme/nvme-cli

Package: nvme-cli
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: userspace tooling to control NVMe drives
 NVMe is a fast, scalable, direct attached storage interface, accessing
 solid state drives through PCIe.
 .
 The nvme CLI contains core management tools with minimal dependencies.

## nvme-cli 0.7

=== debian/changelog ===
nvme-cli (0.7-1) unstable; urgency=medium

  * New upstream release
  * Bump Standard-Version to 3.9.8, no changes required.

 -- Breno Leitao <brenohl@br.ibm.com>  Tue, 21 Jun 2016 16:32:22 -0400

=== debian/control ===
--- 
+++ 
@@ -1,9 +1,8 @@
 Source: nvme-cli
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Breno Leitao <brenohl@br.ibm.com>
+Maintainer: Breno Leitao <brenohl@br.ibm.com>
 Section: admin
 Priority: optional
-Standards-Version: 3.9.7
+Standards-Version: 3.9.8
 Build-Depends: debhelper (>= 9), libudev-dev
 Homepage: https://github.com/linux-nvme/nvme-cli

## nvme-cli 0.8

=== Makefile ===
--- 
+++ 
@@ -1,10 +1,10 @@
 CFLAGS += -std=gnu99 -O2 -g -Wall -Werror
-CPPFLAGS += -I $(SRC) -D_GNU_SOURCE
+CPPFLAGS += -D_GNU_SOURCE
 NVME = nvme
 INSTALL ?= install
-SRC = ./src
 DESTDIR =
 PREFIX ?= /usr/local
+SYSCONFDIR = /etc
 SBINDIR = $(PREFIX)/sbin
 LIBUDEV := $(shell ld -o /dev/null -ludev >/dev/null 2>&1; echo $$?)
 LIB_DEPENDS =
@@ -30,20 +30,18 @@
 
 NVME_DPKG_VERSION=1~`lsb_release -sc`
 
-nvme: nvme.c ./linux/nvme.h argconfig.o suffix.o nvme-print.o nvme-ioctl.o NVME-VERSION-FILE
-	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c $(LDFLAGS) -o $(NVME) argconfig.o suffix.o nvme-print.o nvme-ioctl.o
+OBJS := argconfig.o suffix.o parser.o nvme-print.o nvme-ioctl.o \
+	nvme-lightnvm.o fabrics.o json.o plugin.o intel-nvme.o \
+	lnvm-nvme.o
 
-nvme-ioctl.o: nvme-ioctl.c nvme-ioctl.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c nvme-ioctl.c
+nvme: nvme.c nvme.h $(OBJS) NVME-VERSION-FILE
+	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c $(LDFLAGS) -o $(NVME) $(OBJS)
 
-argconfig.o: $(SRC)/argconfig.c $(SRC)/argconfig.h $(SRC)/suffix.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c $(SRC)/argconfig.c
+nvme.o: nvme.c nvme.h nvme-print.h nvme-ioctl.h argconfig.h suffix.h nvme-lightnvm.h fabrics.h
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
 
-suffix.o: $(SRC)/suffix.c $(SRC)/suffix.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c $(SRC)/suffix.c
-
-nvme-print.o: nvme-print.c nvme-print.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c nvme-print.c
+%.o: %.c %.h nvme.h linux/nvme_ioctl.h
+	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
 
 doc: $(NVME)
 	$(MAKE) -C Documentation
@@ -64,7 +62,11 @@
 	$(INSTALL) -d $(DESTDIR)$(SBINDIR)
 	$(INSTALL) -m 755 nvme $(DESTDIR)$(SBINDIR)
 
-install: install-bin install-man
+install-bash-completion:
+	$(INSTALL) -d $(DESTDIR)$(SYSCONFDIR)/bash_completion.d
+	$(INSTALL) -m 644 -T ./completions/bash-nvme-completion.sh $(DESTDIR)$(SYSCONFDIR)/bash_completion.d/nvme
+
+install: install-bin install-man install-bash-completion
 
 nvme.spec: nvme.spec.in NVME-VERSION-FILE
 	sed -e 's/@@VERSION@@/$(NVME_VERSION)/g' < $< > $@+

=== debian/changelog ===
nvme-cli (0.8-2) unstable; urgency=medium

  * Add a patch to enable nvme-cli to compile on 32 bits system (Thanks Steve
    Langasek) (Closes: #830521)

 -- Breno Leitao <brenohl@br.ibm.com>  Mon, 11 Jul 2016 12:48:11 -0400

nvme-cli (0.8-1) unstable; urgency=medium

  * New upstream release

 -- Breno Leitao <brenohl@br.ibm.com>  Sun, 03 Jul 2016 07:12:26 -0400

## nvme-cli 0.9

=== Makefile ===
--- 
+++ 
@@ -32,10 +32,10 @@
 
 OBJS := argconfig.o suffix.o parser.o nvme-print.o nvme-ioctl.o \
 	nvme-lightnvm.o fabrics.o json.o plugin.o intel-nvme.o \
-	lnvm-nvme.o
+	lnvm-nvme.o memblaze-nvme.o
 
 nvme: nvme.c nvme.h $(OBJS) NVME-VERSION-FILE
-	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c $(LDFLAGS) -o $(NVME) $(OBJS)
+	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $(NVME) $(OBJS) $(LDFLAGS)
 
 nvme.o: nvme.c nvme.h nvme-print.h nvme-ioctl.h argconfig.h suffix.h nvme-lightnvm.h fabrics.h
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<

=== debian/changelog ===
nvme-cli (0.9-1~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Paul Wise <pabs@debian.org>  Wed, 07 Dec 2016 09:38:31 +0800

nvme-cli (0.9-1) unstable; urgency=medium

  * New upstream release

 -- Breno Leitao <leitao@debian.org>  Thu, 06 Oct 2016 13:03:59 -0400

## nvme-cli 1.0

=== Makefile ===
--- 
+++ 
@@ -1,5 +1,5 @@
 CFLAGS += -std=gnu99 -O2 -g -Wall -Werror
-CPPFLAGS += -D_GNU_SOURCE
+CPPFLAGS += -D_GNU_SOURCE -D__CHECK_ENDIAN__
 NVME = nvme
 INSTALL ?= install
 DESTDIR =
@@ -32,7 +32,7 @@
 
 OBJS := argconfig.o suffix.o parser.o nvme-print.o nvme-ioctl.o \
 	nvme-lightnvm.o fabrics.o json.o plugin.o intel-nvme.o \
-	lnvm-nvme.o memblaze-nvme.o
+	lnvm-nvme.o memblaze-nvme.o nvme-models.o
 
 nvme: nvme.c nvme.h $(OBJS) NVME-VERSION-FILE
 	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $(NVME) $(OBJS) $(LDFLAGS)

=== debian/changelog ===
nvme-cli (1.0-3~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Paul Wise <pabs@debian.org>  Fri, 03 Feb 2017 08:11:53 +0800

nvme-cli (1.0-3) unstable; urgency=medium

  * Last commit didn't fix all the problem for 32-bits archs.
    Fixing it properly now. (Closes: #847232) 

 -- Breno Leitao <leitao@debian.org>  Wed, 14 Dec 2016 07:51:29 -0500

nvme-cli (1.0-2) unstable; urgency=medium

  * Fix FTBFS in 32-bits arch. (Closes: #847232)

 -- Breno Leitao <leitao@debian.org>  Tue, 13 Dec 2016 08:31:42 -0500

nvme-cli (1.0-1) unstable; urgency=medium

  * New upstream release.

 -- Breno Leitao <leitao@debian.org>  Thu, 24 Nov 2016 15:15:28 -0500

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,5 @@
 Source: nvme-cli
-Maintainer: Breno Leitao <brenohl@br.ibm.com>
+Maintainer: Breno Leitao <leitao@debian.org>
 Section: admin
 Priority: optional
 Standards-Version: 3.9.8

## nvme-cli 1.1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
-CFLAGS += -std=gnu99 -O2 -g -Wall -Werror
+CFLAGS ?= -O2 -g -Wall -Werror
+CFLAGS += -std=gnu99
 CPPFLAGS += -D_GNU_SOURCE -D__CHECK_ENDIAN__
 NVME = nvme
 INSTALL ?= install
@@ -6,7 +7,6 @@
 PREFIX ?= /usr/local
 SYSCONFDIR = /etc
 SBINDIR = $(PREFIX)/sbin
-LIBUDEV := $(shell ld -o /dev/null -ludev >/dev/null 2>&1; echo $$?)
 LIB_DEPENDS =
 
 RPMBUILD = rpmbuild
@@ -14,12 +14,6 @@
 RM = rm -f
 
 AUTHOR=Keith Busch <keith.busch@intel.com>
-
-ifeq ($(LIBUDEV),0)
-	override LDFLAGS += -ludev
-	override CFLAGS  += -DLIBUDEV_EXISTS
-	override LIB_DEPENDS += udev
-endif
 
 default: $(NVME)
 
@@ -45,6 +39,9 @@
 
 doc: $(NVME)
 	$(MAKE) -C Documentation
+
+test:
+	$(MAKE) -C tests/ run
 
 all: doc
 
@@ -136,4 +133,4 @@
 	$(RPMBUILD) -ta nvme-$(NVME_VERSION).tar.gz
 
 .PHONY: default doc all clean clobber install-man install-bin install
-.PHONY: dist pkg dist-orig deb deb-light rpm FORCE
+.PHONY: dist pkg dist-orig deb deb-light rpm FORCE test

=== debian/changelog ===
nvme-cli (1.1-1) unstable; urgency=medium

  * New upstream release

 -- Breno Leitao <leitao@debian.org>  Mon, 06 Feb 2017 08:20:45 -0500

=== debian/control ===
--- 
+++ 
@@ -3,7 +3,7 @@
 Section: admin
 Priority: optional
 Standards-Version: 3.9.8
-Build-Depends: debhelper (>= 9), libudev-dev
+Build-Depends: debhelper (>= 9), libudev-dev, python-nose
 Homepage: https://github.com/linux-nvme/nvme-cli
 
 Package: nvme-cli

## nvme-cli 1.3

=== debian/changelog ===
nvme-cli (1.3-1) unstable; urgency=medium

  * New upstream release. Thanks Rodrigo R. Galvão <rosattig@br.ibm.com> 

 -- Breno Leitao <leitao@debian.org>  Wed, 14 Jun 2017 16:36:20 -0300

=== debian/control ===
--- 
+++ 
@@ -1,4 +1,5 @@
 Source: nvme-cli
+Uploaders: Rodrigo R. Galvao <rosattig@br.ibm.com>
 Maintainer: Breno Leitao <leitao@debian.org>
 Section: admin
 Priority: optional

## nvme-cli 1.5

=== Makefile ===
--- 
+++ 
@@ -1,6 +1,7 @@
 CFLAGS ?= -O2 -g -Wall -Werror
 CFLAGS += -std=gnu99
 CPPFLAGS += -D_GNU_SOURCE -D__CHECK_ENDIAN__
+LIBUUID = $(shell $(LD) -o /dev/null -luuid >/dev/null 2>&1; echo $$?)
 NVME = nvme
 INSTALL ?= install
 DESTDIR =
@@ -8,6 +9,12 @@
 SYSCONFDIR = /etc
 SBINDIR = $(PREFIX)/sbin
 LIB_DEPENDS =
+
+ifeq ($(LIBUUID),0)
+	override LDFLAGS += -luuid
+	override CFLAGS += -DLIBUUID
+	override LIB_DEPENDS += uuid
+endif
 
 RPMBUILD = rpmbuild
 TAR = tar
@@ -26,7 +33,7 @@
 
 OBJS := argconfig.o suffix.o parser.o nvme-print.o nvme-ioctl.o \
 	nvme-lightnvm.o fabrics.o json.o plugin.o intel-nvme.o \
-	lnvm-nvme.o memblaze-nvme.o nvme-models.o
+	lnvm-nvme.o memblaze-nvme.o wdc-nvme.o nvme-models.o huawei-nvme.o
 
 nvme: nvme.c nvme.h $(OBJS) NVME-VERSION-FILE
 	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $(NVME) $(OBJS) $(LDFLAGS)
@@ -48,6 +55,7 @@
 clean:
 	$(RM) $(NVME) *.o *~ a.out NVME-VERSION-FILE *.tar* nvme.spec version control nvme-*.deb
 	$(MAKE) -C Documentation clean
+	$(RM) tests/*.pyc
 
 clobber: clean
 	$(MAKE) -C Documentation clobber
@@ -60,8 +68,8 @@
 	$(INSTALL) -m 755 nvme $(DESTDIR)$(SBINDIR)
 
 install-bash-completion:
-	$(INSTALL) -d $(DESTDIR)$(SYSCONFDIR)/bash_completion.d
-	$(INSTALL) -m 644 -T ./completions/bash-nvme-completion.sh $(DESTDIR)$(SYSCONFDIR)/bash_completion.d/nvme
+	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/bash_completion.d
+	$(INSTALL) -m 644 -T ./completions/bash-nvme-completion.sh $(DESTDIR)$(PREFIX)/share/bash_completion.d/nvme
 
 install: install-bin install-man install-bash-completion

=== Documentation/Makefile ===
--- 
+++ 
@@ -91,7 +91,7 @@
 endif
 
 DESTDIR =
-PREFIX := /usr/local
+PREFIX ?= /usr/local
 
 all: man html

=== debian/changelog ===
nvme-cli (1.5-1ubuntu1.2) bionic; urgency=medium

  * d/p/Fix-bash-completion.patch:
    - Move bash completion files to correct location (LP: #1800544)

 -- Heitor Alves de Siqueira <halves@canonical.com>  Wed, 24 Nov 2021 12:37:26 +0000

nvme-cli (1.5-1ubuntu1.1) bionic; urgency=medium

  * d/control, d/nvme-cli.postinst:
    - add uuid-dev build dep so 'gen-hostnqn' command works
    - add uuid-runtime dep as postinst calls uuidgen
    - generate /etc/nvme/hostid and hostnqn files during install
      (LP: #1867366)

 -- Dan Streetman <ddstreet@canonical.com>  Mon, 31 Aug 2020 17:54:07 -0400

nvme-cli (1.5-1ubuntu1) bionic; urgency=medium

  * debian/patches/Add-support-for-Micron-plugin.patch:
    - Add upstream patch to enable support for Micron NVMe devices,
      specifically enabling the feature to update firmware. (LP: #1838555)

 -- Matthew Ruffell <matthew.ruffell@canonical.com>  Sat, 05 Oct 2019 23:26:53 -0500

nvme-cli (1.5-1) unstable; urgency=medium

  * New upstream release

 -- Breno Leitao <leitao@debian.org>  Mon, 29 Jan 2018 12:59:02 -0500

nvme-cli (1.4-1) unstable; urgency=medium

  * New upstream release
  * Standard Version upgraded to 4.0.1

 -- Breno Leitao <leitao@debian.org>  Mon, 02 Oct 2017 08:27:23 -0400

=== debian/control ===
Source: nvme-cli
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Breno Leitao <leitao@debian.org>
Section: admin
Priority: optional
Standards-Version: 4.1.1
Build-Depends: debhelper (>= 9), libudev-dev, python-nose, uuid-dev
Homepage: https://github.com/linux-nvme/nvme-cli

Package: nvme-cli
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}, uuid-runtime
Description: userspace tooling to control NVMe drives
 NVMe is a fast, scalable, direct attached storage interface, accessing
 solid state drives through PCIe.
 .
 The nvme CLI contains core management tools with minimal dependencies.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS = hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr

override_dh_auto_test:
	# Overriding auto test, since the tests require that the build machine
	# has a NVME device.

=== debian/watch ===
version=3
opts="filenamemangle=s/(?:.*?)?v?(\d[\d.]*)\.tar\.gz/nvme-cli-$1.tar.gz/" \
https://github.com/linux-nvme/nvme-cli/tags (?:.*?/)?v?(\d[\d.]*)\.tar\.gz

## nvme-cli 1.6

=== debian/changelog ===
nvme-cli (1.6-1) unstable; urgency=medium

  * New upstream release

 -- Breno Leitao <leitao@debian.org>  Mon, 06 Aug 2018 12:12:32 -0400

## nvme-cli 1.7

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,4 @@
-CFLAGS ?= -O2 -g -Wall -Werror
+CFLAGS ?= -O2 -g -Wall -Werror -I.
 CFLAGS += -std=gnu99
 CPPFLAGS += -D_GNU_SOURCE -D__CHECK_ENDIAN__
 LIBUUID = $(shell $(LD) -o /dev/null -luuid >/dev/null 2>&1; echo $$?)
@@ -32,17 +32,31 @@
 NVME_DPKG_VERSION=1~`lsb_release -sc`
 
 OBJS := argconfig.o suffix.o parser.o nvme-print.o nvme-ioctl.o \
-	nvme-lightnvm.o fabrics.o json.o plugin.o intel-nvme.o \
-	lnvm-nvme.o memblaze-nvme.o wdc-nvme.o nvme-models.o huawei-nvme.o
+	nvme-lightnvm.o fabrics.o json.o nvme-models.o plugin.o
 
-nvme: nvme.c nvme.h $(OBJS) NVME-VERSION-FILE
-	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $(NVME) $(OBJS) $(LDFLAGS)
+PLUGIN_OBJS :=					\
+	plugins/intel/intel-nvme.o		\
+	plugins/lnvm/lnvm-nvme.o		\
+	plugins/memblaze/memblaze-nvme.o	\
+	plugins/wdc/wdc-nvme.o			\
+	plugins/wdc/wdc-utils.o			\
+	plugins/huawei/huawei-nvme.o		\
+	plugins/netapp/netapp-nvme.o		\
+	plugins/toshiba/toshiba-nvme.o		\
+	plugins/micron/micron-nvme.o		\
+	plugins/seagate/seagate-nvme.o
+
+nvme: nvme.c nvme.h $(OBJS) $(PLUGIN_OBJS) NVME-VERSION-FILE
+	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $(NVME) $(OBJS) $(PLUGIN_OBJS) $(LDFLAGS)
+
+verify-no-dep: nvme.c nvme.h $(OBJS) NVME-VERSION-FILE
+	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $@ $(OBJS) $(LDFLAGS)
 
 nvme.o: nvme.c nvme.h nvme-print.h nvme-ioctl.h argconfig.h suffix.h nvme-lightnvm.h fabrics.h
 	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
 
-%.o: %.c %.h nvme.h linux/nvme_ioctl.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
+%.o: %.c %.h nvme.h linux/nvme_ioctl.h nvme-ioctl.h nvme-print.h argconfig.h
+	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<
 
 doc: $(NVME)
 	$(MAKE) -C Documentation
@@ -53,9 +67,10 @@
 all: doc
 
 clean:
-	$(RM) $(NVME) *.o *~ a.out NVME-VERSION-FILE *.tar* nvme.spec version control nvme-*.deb
+	$(RM) $(NVME) $(OBJS) $(PLUGIN_OBJS) *~ a.out NVME-VERSION-FILE *.tar* nvme.spec version control nvme-*.deb
 	$(MAKE) -C Documentation clean
 	$(RM) tests/*.pyc
+	$(RM) verify-no-dep
 
 clobber: clean
 	$(MAKE) -C Documentation clobber
@@ -68,10 +83,14 @@
 	$(INSTALL) -m 755 nvme $(DESTDIR)$(SBINDIR)
 
 install-bash-completion:
-	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/bash_completion.d
-	$(INSTALL) -m 644 -T ./completions/bash-nvme-completion.sh $(DESTDIR)$(PREFIX)/share/bash_completion.d/nvme
+	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
+	$(INSTALL) -m 644 -T ./completions/bash-nvme-completion.sh $(DESTDIR)$(PREFIX)/share/bash-completion/completions/nvme
 
-install: install-bin install-man install-bash-completion
+install-zsh-completion:
+	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/zsh/site-functions
+	$(INSTALL) -m 644 -T ./completions/_nvme $(DESTDIR)$(PREFIX)/share/zsh/site-functions/_nvme
+
+install: install-bin install-man install-bash-completion install-zsh-completion
 
 nvme.spec: nvme.spec.in NVME-VERSION-FILE
 	sed -e 's/@@VERSION@@/$(NVME_VERSION)/g' < $< > $@+

=== debian/changelog ===
nvme-cli (1.7-1) unstable; urgency=medium

  * New upstream release

 -- Breno Leitao <leitao@debian.org>  Mon, 21 Jan 2019 06:25:35 -0500

## nvme-cli 1.9

=== debian/changelog ===
nvme-cli (1.9-1ubuntu0.2) focal; urgency=medium

  * NVMe show-regs command forcibly reboots ARM-based VM (LP: #2072381)
    - d/p/lp2072381-0001-Avoid-using-unsupported-load-store-instruct.patch

 -- Chengen Du <chengen.du@canonical.com>  Sat, 06 Jul 2024 04:02:39 +0000

nvme-cli (1.9-1ubuntu0.1) focal; urgency=medium

  * d/control, d/rules, d/nvme-cli.postinst, d/nvme-cli.maintscript:
    - wrap-and-sort -ast
    - add uuid-dev build dep so 'gen-hostnqn' command works
    - add uuid-runtime as postinst may call uuidgen
    - generate /etc/nvme/host* files at install not build (LP: #1867366)

 -- Dan Streetman <ddstreet@canonical.com>  Sun, 06 Sep 2020 22:11:24 -0400

nvme-cli (1.9-1) unstable; urgency=medium

  * New upstream release 
  * Fixed dependencies (Closes: #944832) 

 --  Breno Leitao <leitao@debian.org>  Sat, 23 Nov 2019 13:40:40 +0000

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,21 @@
 Section: admin
 Priority: optional
 Standards-Version: 4.1.1
-Build-Depends: debhelper (>= 9), libudev-dev, python-nose, uuid-dev
+Build-Depends:
+ debhelper (>= 9),
+ libudev-dev,
+ pci.ids,
+ python3-nose,
+ uuid-dev,
+ uuid-runtime,
 Homepage: https://github.com/linux-nvme/nvme-cli
 
 Package: nvme-cli
 Architecture: any
-Depends: ${shlibs:Depends}, ${misc:Depends}, uuid-runtime
+Depends:
+ ${misc:Depends},
+ ${shlibs:Depends},
+ uuid-runtime,
 Description: userspace tooling to control NVMe drives
  NVMe is a fast, scalable, direct attached storage interface, accessing
  solid state drives through PCIe.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh $@

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr
	# Remove build-time unique id files, instead these will be
	# generated by the postinst script
	rm -f debian/nvme-cli/etc/nvme/hostid
	rm -f debian/nvme-cli/etc/nvme/hostnqn

override_dh_auto_test:
	# Overriding auto test, since the tests require that the build machine
	# has a NVME device.

## nvme-cli 1.12

=== Documentation/Makefile ===
--- 
+++ 
@@ -18,6 +18,23 @@
 SP_ARTICLES += $(API_DOCS)
 SP_ARTICLES += $(TECH_DOCS)
 
+ifneq ($(findstring $(MAKEFLAGS),s),s)
+ifndef V
+	QUIET_ASCIIDOC  = @echo '   ' ASCIIDOC $@;
+	QUIET_XMLTO     = @echo '   ' XMLTO $@;
+	QUIET_DB2TEXI   = @echo '   ' DB2TEXI $@;
+	QUIET_MAKEINFO  = @echo '   ' MAKEINFO $@;
+	QUIET_DBLATEX   = @echo '   ' DBLATEX $@;
+	QUIET_XSLTPROC  = @echo '   ' XSLTPROC $@;
+	QUIET_GEN       = @echo '   ' GEN $@;
+	QUIET_LINT      = @echo '   ' LINT $@;
+	QUIET_STDERR    = 2> /dev/null
+	QUIET_SUBDIR0   = +@subdir=
+	QUIET_SUBDIR1   = ;$(NO_SUBDIR) echo '   ' SUBDIR $$subdir; \
+			$(MAKE) $(PRINT_DIR) -C $$subdir
+	export V
+endif
+endif
 
 DOC_MAN1 = $(patsubst %.txt,%.1,$(MAN1_TXT))
 
@@ -28,13 +45,26 @@
 TXT_TO_XML = $(ASCIIDOC_COMMON) -b $(ASCIIDOC_DOCBOOK)
 MANPAGE_XSL = manpage-normal.xsl
 XMLTO = xmlto
-XMLTO_EXTRA =
+XMLTO_EXTRA = --skip-validation
 INSTALL ?= install
 RM ?= rm -f
 MAN_REPO = ../../nvme-manpages
 
 ASCIIDOC_HTML = xhtml11
 ASCIIDOC_CONF = -f asciidoc.conf
+
+ifdef USE_ASCIIDOCTOR
+ASCIIDOC = asciidoctor
+ASCIIDOC_CONF =
+ASCIIDOC_HTML = xhtml5
+ASCIIDOC_DOCBOOK = docbook5
+ASCIIDOC_EXTRA += -acompat-mode
+ASCIIDOC_EXTRA += -I. -rasciidoctor-extensions
+ASCIIDOC_EXTRA += -alitdd='&\#x2d;&\#x2d;'
+ASCIIDOC_EXTRA += -amansource='NVMe'
+ASCIIDOC_EXTRA += -amanmanual='NVMe Manual'
+endif
+
 ASCIIDOC_COMMON = $(ASCIIDOC) $(ASCIIDOC_EXTRA) $(ASCIIDOC_CONF)
 TXT_TO_HTML = $(ASCIIDOC_COMMON) -b $(ASCIIDOC_HTML)

=== debian/changelog ===
nvme-cli (1.12-5) unstable; urgency=medium

  * Add uuid-runtime as dependency. (Closes: #970637)

 --  <leitao@debian.org>  Tue, 22 Sep 2020 20:37:51 +0100

nvme-cli (1.12-4) unstable; urgency=medium

  * Fix udev rules and config files. Thanks intrigeri (Closes: #968769)
  * Remove debian/package.bash-completion (Closes: #969345)

 --  <leitao@debian.org>  Sun, 20 Sep 2020 10:39:01 +0100

nvme-cli (1.12-3) unstable; urgency=medium

  * Bring debhelper compat to 13 and fix build deps (Closes: ##969183)

 --  <leitao@debian.org>  Sun, 20 Sep 2020 10:23:14 +0100

nvme-cli (1.12-2) unstable; urgency=medium

  *  Generate /etc/nvme/host* files at install time, not build time.
     Thanks Dan for the patch. (Closes: #969340)

 --  <leitao@debian.org>  Sun, 20 Sep 2020 10:14:36 +0100

nvme-cli (1.12-1) unstable; urgency=medium

  * New upstream release.

 --  <leit@debian.org>  Sat, 20 Jun 2020 09:27:22 +0100

=== debian/control ===
--- 
+++ 
@@ -1,14 +1,12 @@
 Source: nvme-cli
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Breno Leitao <leitao@debian.org>
+Maintainer: Breno Leitao <leitao@debian.org>
 Section: admin
 Priority: optional
 Standards-Version: 4.1.1
 Build-Depends:
- debhelper (>= 9),
- libudev-dev,
+ debhelper-compat (= 13),
  pci.ids,
- python3-nose,
+ pkg-config,
  uuid-dev,
  uuid-runtime,
 Homepage: https://github.com/linux-nvme/nvme-cli

=== debian/rules ===
--- 
+++ 
@@ -6,11 +6,12 @@
 	dh $@
 
 override_dh_auto_install:
-	dh_auto_install -- PREFIX=/usr
+	dh_auto_install -- PREFIX=/usr UDEVDIR=/lib/udev
 	# Remove build-time unique id files, instead these will be
 	# generated by the postinst script
 	rm -f debian/nvme-cli/etc/nvme/hostid
 	rm -f debian/nvme-cli/etc/nvme/hostnqn
+	rm -f debian/nvme-cli/usr/lib/dracut/dracut.conf.d/70-nvmf-autoconnect.conf
 
 override_dh_auto_test:
 	# Overriding auto test, since the tests require that the build machine

## nvme-cli 1.14

=== debian/changelog ===
nvme-cli (1.14-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 1.14:
    - fixes bug that can cause some Samsung controllers to go
      offline (Closes: #989840).
  * Removing whitespaces at EOL.
  * Correcting name entries in changelog.
  * Adding vcs fields.
  * Updating to standards version 4.5.1.
  * Adding rules-requires-root field.
  * Repeating section for binary packages in control for consistency
    reasons.
  * Updating format url in copyright.
  * Updating source url in copyright.
  * Adding upstream-name in copyright.
  * Adding upstream-contact in copyright.
  * Updating year in copyright.
  * Using default GPL license blocks in copyright.
  * Making postinst executable in source tree.
  * Rewriting postinst with the standard maintainer script.
  * Removing spurious bash-completion file in source tree.
  * Harmonizing rules file.
  * Removing spurious source/include-binaries file (Closes: #944833).
  * Updating watch file to version 4.
  * Wrap and sorting debian directory.
  * Updating package description.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 02 Jul 2021 23:08:03 +0200

nvme-cli (1.12-8) unstable; urgency=medium

  * Adopting package.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 02 Jul 2021 22:41:27 +0200

nvme-cli (1.12-7) unstable; urgency=medium

  * Orphaning the package

 -- Breno Leitao <leitao@debian.org>  Fri, 02 Jul 2021 19:37:48 +0100

=== debian/control ===
Source: nvme-cli
Section: admin
Priority: optional
Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Build-Depends:
 debhelper-compat (= 13),
 pci.ids,
 pkg-config,
 uuid-dev,
 uuid-runtime,
Rules-Requires-Root: no
Standards-Version: 4.5.1
Homepage: https://github.com/linux-nvme/nvme-cli
Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-cli
Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-cli

Package: nvme-cli
Section: admin
Architecture: any
Depends:
 uuid-runtime,
 ${misc:Depends},
 ${shlibs:Depends},
Description: NVMe management tool
 NVM Express (NVMe) is a interface specification for accessing non-volatile
 storage media, typically modern solid state drives (SSDs) through PCI Express
 (PCIe).
 .
 The nvme-cli tool provides management functions for these devices.

=== debian/rules ===
#!/usr/bin/make -f

export DEB_BUILD_MAINT_OPTIONS=hardening=+all

%:
	dh ${@}

override_dh_auto_install:
	dh_auto_install -- PREFIX=/usr UDEVDIR=/lib/udev

	# removing unique files
	rm -f debian/nvme-cli/etc/nvme/hostid
	rm -f debian/nvme-cli/etc/nvme/hostnqn
	rm -f debian/nvme-cli/usr/lib/dracut/dracut.conf.d/70-nvmf-autoconnect.conf

override_dh_auto_test:
	# disabled, requires a NVMe device

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/nvme-cli-$1\.tar\.gz/ \
https://github.com/linux-nvme/nvme-cli/releases .*/v?(\d\S+)\.tar\.gz

## nvme-cli 1.16

=== Makefile ===
--- 
+++ 
@@ -1,13 +1,22 @@
-CFLAGS ?= -O2 -g -Wall -Werror -I.
-CFLAGS += -std=gnu99
-CPPFLAGS += -D_GNU_SOURCE -D__CHECK_ENDIAN__
+CFLAGS ?= -O2 -g -Wall -Werror
+override CFLAGS += -std=gnu99 -I.
+override CPPFLAGS += -D_GNU_SOURCE -D__CHECK_ENDIAN__
 LIBUUID = $(shell $(LD) -o /dev/null -luuid >/dev/null 2>&1; echo $$?)
+LIBHUGETLBFS = $(shell $(LD) -o /dev/null -lhugetlbfs >/dev/null 2>&1; echo $$?)
+HAVE_SYSTEMD = $(shell pkg-config --exists libsystemd  --atleast-version=242; echo $$?)
+LIBJSONC = $(shell pkg-config --atleast-version=0.14 json-c; echo $$?)
 NVME = nvme
 INSTALL ?= install
 DESTDIR =
-PREFIX ?= /usr/local
+DESTDIROLD = /usr/local/sbin
+PREFIX ?= /usr
 SYSCONFDIR = /etc
 SBINDIR = $(PREFIX)/sbin
+LIBDIR ?= $(PREFIX)/lib
+SYSTEMDDIR ?= $(LIBDIR)/systemd
+UDEVDIR ?= $(SYSCONFDIR)/udev
+UDEVRULESDIR ?= $(UDEVDIR)/rules.d
+DRACUTDIR ?= $(LIBDIR)/dracut
 LIB_DEPENDS =
 
 ifeq ($(LIBUUID),0)
@@ -16,11 +25,35 @@
 	override LIB_DEPENDS += uuid
 endif
 
+ifeq ($(LIBHUGETLBFS),0)
+	override LDFLAGS += -lhugetlbfs
+	override CFLAGS += -DLIBHUGETLBFS
+	override LIB_DEPENDS += hugetlbfs
+endif
+
+INC=-Iutil
+
+ifeq ($(HAVE_SYSTEMD),0)
+	override LDFLAGS += -lsystemd
+	override CFLAGS += -DHAVE_SYSTEMD
+endif
+
+ifeq ($(LIBJSONC), 0)
+	override LDFLAGS += -ljson-c
+	override CFLAGS += -DLIBJSONC
+endif
+
 RPMBUILD = rpmbuild
 TAR = tar
 RM = rm -f
 
-AUTHOR=Keith Busch <keith.busch@intel.com>
+AUTHOR=Keith Busch <kbusch@kernel.org>
+
+ifneq ($(findstring $(MAKEFLAGS),s),s)
+ifndef V
+	QUIET_CC	= @echo '   ' CC $@;
+endif
+endif
 
 default: $(NVME)
 
@@ -31,11 +64,19 @@
 
 NVME_DPKG_VERSION=1~`lsb_release -sc`
 
-OBJS := argconfig.o suffix.o parser.o nvme-print.o nvme-ioctl.o \
-	nvme-lightnvm.o fabrics.o json.o nvme-models.o plugin.o
+OBJS := nvme-print.o nvme-ioctl.o nvme-rpmb.o \
+	nvme-lightnvm.o fabrics.o nvme-models.o plugin.o \
+	nvme-status.o nvme-filters.o nvme-topology.o
+
+UTIL_OBJS := util/argconfig.o util/suffix.o util/parser.o \
+	util/cleanup.o util/log.o
+ifneq ($(LIBJSONC), 0)
+override UTIL_OBJS += util/json.o
+endif
 
 PLUGIN_OBJS :=					\
 	plugins/intel/intel-nvme.o		\
+	plugins/amzn/amzn-nvme.o		\
 	plugins/lnvm/lnvm-nvme.o		\
 	plugins/memblaze/memblaze-nvme.o	\
 	plugins/wdc/wdc-nvme.o			\
@@ -44,19 +85,30 @@
 	plugins/netapp/netapp-nvme.o		\
 	plugins/toshiba/toshiba-nvme.o		\
 	plugins/micron/micron-nvme.o		\
-	plugins/seagate/seagate-nvme.o
-
-nvme: nvme.c nvme.h $(OBJS) $(PLUGIN_OBJS) NVME-VERSION-FILE
-	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $(NVME) $(OBJS) $(PLUGIN_OBJS) $(LDFLAGS)
-
-verify-no-dep: nvme.c nvme.h $(OBJS) NVME-VERSION-FILE
-	$(CC) $(CPPFLAGS) $(CFLAGS) nvme.c -o $@ $(OBJS) $(LDFLAGS)
-
-nvme.o: nvme.c nvme.h nvme-print.h nvme-ioctl.h argconfig.h suffix.h nvme-lightnvm.h fabrics.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) -c $<
-
-%.o: %.c %.h nvme.h linux/nvme_ioctl.h nvme-ioctl.h nvme-print.h argconfig.h
-	$(CC) $(CPPFLAGS) $(CFLAGS) -o $@ -c $<
+	plugins/seagate/seagate-nvme.o 		\
+	plugins/virtium/virtium-nvme.o		\
+	plugins/shannon/shannon-nvme.o		\
+	plugins/dera/dera-nvme.o 		\
+	plugins/scaleflux/sfx-nvme.o		\
+	plugins/transcend/transcend-nvme.o	\
+	plugins/zns/zns.o	        		\
+	plugins/nvidia/nvidia-nvme.o        \
+	plugins/ymtc/ymtc-nvme.o
+
+nvme: nvme.c nvme.h $(OBJS) $(PLUGIN_OBJS) $(UTIL_OBJS) NVME-VERSION-FILE
+	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) $< -o $(NVME) $(OBJS) $(PLUGIN_OBJS) $(UTIL_OBJS) $(LDFLAGS)
+
+verify-no-dep: nvme.c nvme.h $(OBJS) $(UTIL_OBJS) NVME-VERSION-FILE
+	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) $< -o $@ $(OBJS) $(UTIL_OBJS) $(LDFLAGS)
+
+nvme.o: nvme.c nvme.h nvme-print.h nvme-ioctl.h util/argconfig.h util/suffix.h nvme-lightnvm.h fabrics.h
+	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) -c $<
+
+%.o: %.c %.h nvme.h linux/nvme.h linux/nvme_ioctl.h nvme-ioctl.h nvme-print.h util/argconfig.h
+	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) -o $@ -c $<
+
+%.o: %.c nvme.h linux/nvme.h linux/nvme_ioctl.h nvme-ioctl.h nvme-print.h util/argconfig.h
+	$(QUIET_CC)$(CC) $(CPPFLAGS) $(CFLAGS) $(INC) -o $@ -c $<
 
 doc: $(NVME)
 	$(MAKE) -C Documentation
@@ -67,7 +119,7 @@
 all: doc
 
 clean:
-	$(RM) $(NVME) $(OBJS) $(PLUGIN_OBJS) *~ a.out NVME-VERSION-FILE *.tar* nvme.spec version control nvme-*.deb
+	$(RM) $(NVME) $(OBJS) $(PLUGIN_OBJS) $(UTIL_OBJS) *~ a.out NVME-VERSION-FILE *.tar* nvme.spec version control nvme-*.deb 70-nvmf-autoconnect.conf
 	$(MAKE) -C Documentation clean
 	$(RM) tests/*.pyc
 	$(RM) verify-no-dep
@@ -79,6 +131,7 @@
 	$(MAKE) -C Documentation install-no-build
 
 install-bin: default
+	$(RM) $(DESTDIROLD)/nvme
 	$(INSTALL) -d $(DESTDIR)$(SBINDIR)
 	$(INSTALL) -m 755 nvme $(DESTDIR)$(SBINDIR)
 
@@ -86,14 +139,47 @@
 	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
 	$(INSTALL) -m 644 -T ./completions/bash-nvme-completion.sh $(DESTDIR)$(PREFIX)/share/bash-completion/completions/nvme
 
+install-systemd:
+	$(INSTALL) -d $(DESTDIR)$(SYSTEMDDIR)/system
+	$(INSTALL) -m 644 ./nvmf-autoconnect/systemd/* $(DESTDIR)$(SYSTEMDDIR)/system
+
+install-udev:
+	$(INSTALL) -d $(DESTDIR)$(UDEVRULESDIR)
+	$(INSTALL) -m 644 ./nvmf-autoconnect/udev-rules/* $(DESTDIR)$(UDEVRULESDIR)
+
+install-dracut: 70-nvmf-autoconnect.conf
+	$(INSTALL) -d $(DESTDIR)$(DRACUTDIR)/dracut.conf.d
+	$(INSTALL) -m 644 $< $(DESTDIR)$(DRACUTDIR)/dracut.conf.d
+
 install-zsh-completion:
 	$(INSTALL) -d $(DESTDIR)$(PREFIX)/share/zsh/site-functions
 	$(INSTALL) -m 644 -T ./completions/_nvme $(DESTDIR)$(PREFIX)/share/zsh/site-functions/_nvme
 
-install: install-bin install-man install-bash-completion install-zsh-completion
+install-hostparams: install-etc
+	if [ ! -s $(DESTDIR)$(SYSCONFDIR)/nvme/hostnqn ]; then \
+		echo `$(DESTDIR)$(SBINDIR)/nvme gen-hostnqn` > $(DESTDIR)$(SYSCONFDIR)/nvme/hostnqn; \
+	fi
+	if [ ! -s $(DESTDIR)$(SYSCONFDIR)/nvme/hostid ]; then \
+		uuidgen > $(DESTDIR)$(SYSCONFDIR)/nvme/hostid; \
+	fi
+
+install-etc:
+	$(INSTALL) -d $(DESTDIR)$(SYSCONFDIR)/nvme
+	touch $(DESTDIR)$(SYSCONFDIR)/nvme/hostnqn
+	touch $(DESTDIR)$(SYSCONFDIR)/nvme/hostid
+	if [ ! -f $(DESTDIR)$(SYSCONFDIR)/nvme/discovery.conf ]; then \
+		$(INSTALL) -m 644 -T ./etc/discovery.conf.in $(DESTDIR)$(SYSCONFDIR)/nvme/discovery.conf; \
+	fi
+
+install-spec: install-bin install-man install-bash-completion install-zsh-completion install-etc install-systemd install-udev install-dracut
+install: install-spec install-hostparams
 
 nvme.spec: nvme.spec.in NVME-VERSION-FILE
 	sed -e 's/@@VERSION@@/$(NVME_VERSION)/g' < $< > $@+
+	mv $@+ $@
+
+70-nvmf-autoconnect.conf: nvmf-autoconnect/dracut-conf/70-nvmf-autoconnect.conf.in
+	sed -e 's#@@UDEVRULESDIR@@#$(UDEVRULESDIR)#g' < $< > $@+
 	mv $@+ $@
 
 dist: nvme.spec
@@ -157,7 +243,10 @@
 	dpkg-deb --build nvme-$(NVME_VERSION)
 
 rpm: dist
-	$(RPMBUILD) -ta nvme-$(NVME_VERSION).tar.gz
+	$(RPMBUILD) --define '_prefix $(DESTDIR)$(PREFIX)' \
+	--define '_libdir $(DESTDIR)${LIBDIR}' \
+	--define '_sysconfdir $(DESTDIR)$(SYSCONFDIR)' \
+	-ta nvme-$(NVME_VERSION).tar.gz
 
 .PHONY: default doc all clean clobber install-man install-bin install
 .PHONY: dist pkg dist-orig deb deb-light rpm FORCE test

=== tests/Makefile ===
###############################################################################
#
#    Makefile : Allows user to run testcases, generate documentation, and
#               perform static code analysis.
#
###############################################################################

NOSE2_OPTIONS="--verbose"

help: all

all:
	@echo "Usage:"
	@echo
	@echo "  make run         - Run all testcases."
	@echo "  make doc         - Generate Documentation."
	@echo "  make cleanall    - removes *pyc, documentation."
	@echo "  make static_check- runs pep8, flake8, pylint on code."

doc:
	@epydoc -v --output=Documentation *.py

run:
	@for i in `ls *.py`; \
	do \
		echo "Running $${i}"; \
		TESTCASE_NAME=`echo $${i} | cut -f 1 -d '.'`; \
		nose2 ${NOSE2_OPTIONS} $${TESTCASE_NAME}; \
	done

static_check:
	@for i in `ls *.py`; \
	do \
		echo "Pylint :- " ; \
		printf "%10s    " $${i}; \
		pylint $${i} 2>&1  | grep "^Your code" |  awk '{print $$7}';\
		echo "--------------------------------------------";\
		pep8 $${i}; \
		echo "pep8 :- "; \
		echo "flake8 :- "; \
		flake8 $${i}; \
	done

cleanall: clean
	@rm -fr *.pyc Documentation

clean:
	@rm -fr *.pyc

=== debian/changelog ===
nvme-cli (1.16-3build1) jammy; urgency=high

  * No change rebuild for ppc64el baseline bump.

 -- Julian Andres Klode <juliank@ubuntu.com>  Thu, 24 Mar 2022 17:21:43 +0100

nvme-cli (1.16-3) sid; urgency=medium

  * Uploading to sid.
  * Building with uuid-dev to pull in libuuid1 depends in again (Closes:
    #1002890).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Fri, 31 Dec 2021 07:32:56 +0100

nvme-cli (1.16-2) sid; urgency=medium

  * Uploading to sid.
  * Updating watch file to use github tags instead of releases.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Tue, 28 Dec 2021 19:22:25 +0100

nvme-cli (1.16-1) sid; urgency=medium

  * Uploading to sid.
  * Merging upstream version 1.16.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 20 Nov 2021 08:04:50 +0100

nvme-cli (1.15-4) sid; urgency=medium

  * Uploading to sid.
  * Reuploading with udeb again, as subsequent uploads are also blocked by
    NEW.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 09 Oct 2021 10:49:12 +0200

nvme-cli (1.15-3) sid; urgency=medium

  * Uploading to sid.
  * Updating to standards version 4.6.0.
  * Disabling udeb for now to workaround 0.15 being stuck in NEW for the
    past 10 weeks.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sat, 09 Oct 2021 10:44:45 +0200

nvme-cli (1.15-2) sid; urgency=medium

  * Uploading to sid.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Sun, 15 Aug 2021 17:45:13 +0200

nvme-cli (1.15-1) experimental; urgency=medium

  * Uploading to experimental.
  * Merging upstream version 1.15.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 12 Aug 2021 14:01:16 +0200

nvme-cli (1.14-4) experimental; urgency=medium

  * Uploading to experimental.
  * Adding nvme-udeb (Closes: #982917).

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 29 Jul 2021 07:41:12 +0200

nvme-cli (1.14-3) experimental; urgency=medium

  * Uploading to experimental.
  * Avoid shipping unused, empty directories for dracut.
  * Adding forgotten continuation dots for LGPL-block in copyright.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 29 Jul 2021 07:20:03 +0200

nvme-cli (1.14-2) experimental; urgency=medium

  * Uploading to experimental.
  * Removing generated files on purge.
  * Completing and correcting debian/copyright.
  * Removing obsolete settings for newer systemd versions.
  * Removing unneeded build-depends.
  * Adding pci.ids to recommends as it's used by some of the plugins.
  * Correcting location of the NVMe-oF systemd service files.

 -- Daniel Baumann <daniel.baumann@progress-linux.org>  Thu, 29 Jul 2021 06:56:57 +0200

=== debian/control ===
Source: nvme-cli
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Daniel Baumann <daniel.baumann@progress-linux.org>
Build-Depends:
 debhelper-compat (= 13),
 pkg-config,
 uuid-dev,
 uuid-runtime,
Rules-Requires-Root: no
Standards-Version: 4.6.0
Homepage: https://github.com/linux-nvme/nvme-cli
Vcs-Browser: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-cli
Vcs-Git: https://git.progress-linux.org/users/daniel.baumann/debian/packages/nvme-cli

Package: nvme-cli
Section: admin
Architecture: any
Depends:
 uuid-runtime,
 ${misc:Depends},
 ${shlibs:Depends},
Recommends:
 pci.ids,
Description: NVMe management tool
 NVM Express (NVMe) is a interface specification for accessing non-volatile
 storage media, typically modern solid state drives (SSDs) through PCI Express
 (PCIe).
 .
 The nvme-cli tool provides management functions for these devices.

Package: nvme-cli-udeb
Section: debian-installer
Package-Type: udeb
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Description: NVMe management tool

=== debian/watch ===
version=4
opts=filenamemangle=s/.+\/v?(\d\S+)\.tar\.gz/nvme-cli-$1\.tar\.gz/ \
https://github.com/linux-nvme/nvme-cli/tags .*/v?(\d\S+)\.tar\.gz
